uniform mat4 sl_modelView;
uniform mat4 sl_modelViewProj;
uniform vec4 sl_fogColorAndDensity;
uniform vec4 sl_lightingColor;

void overrideCirrusLighting(in vec3 lightColor, in vec3 fogColor, in float fogBlend, in float alpha, inout vec4 finalColor);
vec4 overridePosition(in vec4 position);

void main()
{
    vec3 eyePosition = (sl_modelView * vec4(gl_Vertex.x , gl_Vertex.y, gl_Vertex.z, 1.0)).xyz;
    float fogDistance = length(eyePosition);
    float fogExponent = fogDistance * sl_fogColorAndDensity.w;
    float fogFactor = clamp(exp(-abs(fogExponent)), 0.0, 1.0);

    vec4 finalColor;
    finalColor.xyz = mix(sl_fogColorAndDensity.xyz, sl_lightingColor.xyz, fogFactor);
    finalColor.w = fogFactor * sl_lightingColor.w;

    overrideCirrusLighting(sl_lightingColor.xyz, sl_fogColorAndDensity.xyz, fogFactor, sl_lightingColor.w, finalColor);

    gl_FrontColor = finalColor * gl_Color;

    gl_Position = overridePosition(sl_modelViewProj * vec4(gl_Vertex.x, gl_Vertex.y, gl_Vertex.z, 1.0));

    gl_TexCoord[0] = gl_MultiTexCoord0;
}
