uniform vec4 sl_lightPositionOnScreen;
uniform vec4 sl_parameters;
uniform vec4 sl_lightColor;
uniform sampler2D sl_tex2D;
uniform vec4 sl_outputScale;

const int NUM_SAMPLES = 100 ;

void writeFragmentData(in vec4 finalColor);

void main()
{
    float exposure = sl_parameters.x;
    float decay = sl_parameters.y;
    float density = sl_parameters.z;
    float weight = sl_parameters.w;

    vec4 color = vec4(0.0, 0.0, 0.0, 0.0);
    vec2 deltaTextCoord = vec2( gl_TexCoord[0].st - sl_lightPositionOnScreen.xy );
    vec2 textCoo = gl_TexCoord[0].st;
    deltaTextCoord *= 1.0 /  float(NUM_SAMPLES) * density;
    float illuminationDecay = 1.0;

    for(int i=0; i < NUM_SAMPLES ; i++) {
        textCoo -= deltaTextCoord;

        vec4 sampleColor = texture2D(sl_tex2D, textCoo );
        sampleColor.xyz *= smoothstep(0.95, 1.0, sampleColor.y) * 0.5 + 0.5;

        sampleColor *= illuminationDecay * weight;
        color += sampleColor;
        illuminationDecay *= decay;
    }

    color *= exposure;

    color.a = smoothstep(0.2, 1.0, color.y);
    color.xyz *= sl_lightColor.xyz * sl_outputScale.xxx;

    writeFragmentData(color);
}